diff --git a/builtin/cat-file.c b/builtin/cat-file.c
index f6afe67bef..e5d774b097 100644
--- a/builtin/cat-file.c
+++ b/builtin/cat-file.c
@@ -600,7 +600,8 @@ static int collect_loose_object(const struct object_id *oid,
 	return 0;
 }
 
-static int collect_packed_object(const struct object_id *oid,
+static int collect_packed_object(struct repository *repo UNUSED,
+				 const struct object_id *oid,
 				 struct packed_git *pack UNUSED,
 				 uint32_t pos UNUSED,
 				 void *data)
@@ -631,7 +632,8 @@ static int batch_unordered_loose(const struct object_id *oid,
 	return batch_unordered_object(oid, NULL, 0, data);
 }
 
-static int batch_unordered_packed(const struct object_id *oid,
+static int batch_unordered_packed(struct repository *repo UNUSED,
+				  const struct object_id *oid,
 				  struct packed_git *pack,
 				  uint32_t pos,
 				  void *data)
diff --git a/builtin/fsck.c b/builtin/fsck.c
index 9c4e0622b5..0e4b7ec3af 100644
--- a/builtin/fsck.c
+++ b/builtin/fsck.c
@@ -250,7 +250,8 @@ static int mark_loose_unreachable_referents(const struct object_id *oid,
 	return 0;
 }
 
-static int mark_packed_unreachable_referents(const struct object_id *oid,
+static int mark_packed_unreachable_referents(struct repository *repo UNUSED,
+					     const struct object_id *oid,
 					     struct packed_git *pack UNUSED,
 					     uint32_t pos UNUSED,
 					     void *data UNUSED)
@@ -861,7 +862,8 @@ static int mark_loose_for_connectivity(const struct object_id *oid,
 	return 0;
 }
 
-static int mark_packed_for_connectivity(const struct object_id *oid,
+static int mark_packed_for_connectivity(struct repository *repo UNUSED,
+					const struct object_id *oid,
 					struct packed_git *pack UNUSED,
 					uint32_t pos UNUSED,
 					void *data UNUSED)
diff --git a/builtin/pack-objects.c b/builtin/pack-objects.c
index 16e7f5d4ec..bfe0197d12 100644
--- a/builtin/pack-objects.c
+++ b/builtin/pack-objects.c
@@ -3361,7 +3361,8 @@ static int git_pack_config(const char *k, const char *v,
 static int stdin_packs_found_nr;
 static int stdin_packs_hints_nr;
 
-static int add_object_entry_from_pack(const struct object_id *oid,
+static int add_object_entry_from_pack(struct repository *repo UNUSED,
+				      const struct object_id *oid,
 				      struct packed_git *p,
 				      uint32_t pos,
 				      void *_data)
@@ -3901,7 +3902,8 @@ static void show_edge(struct commit *commit)
 	add_preferred_base(&commit->object.oid);
 }
 
-static int add_object_in_unpacked_pack(const struct object_id *oid,
+static int add_object_in_unpacked_pack(struct repository *repo UNUSED,
+				       const struct object_id *oid,
 				       struct packed_git *pack,
 				       uint32_t pos,
 				       void *data UNUSED)
diff --git a/builtin/repack.c b/builtin/repack.c
index 96a4fa234b..de03a3ecfc 100644
--- a/builtin/repack.c
+++ b/builtin/repack.c
@@ -321,7 +321,8 @@ static void prepare_pack_objects(struct child_process *cmd,
  * Write oid to the given struct child_process's stdin, starting it first if
  * necessary.
  */
-static int write_oid(const struct object_id *oid,
+static int write_oid(struct repository *repo,
+		     const struct object_id *oid,
 		     struct packed_git *pack UNUSED,
 		     uint32_t pos UNUSED, void *data)
 {
@@ -332,7 +333,7 @@ static int write_oid(const struct object_id *oid,
 			die(_("could not start pack-objects to repack promisor objects"));
 	}
 
-	if (write_in_full(cmd->in, oid_to_hex(oid), the_hash_algo->hexsz) < 0 ||
+	if (write_in_full(cmd->in, oid_to_hex(oid), repo->hash_algo->hexsz) < 0 ||
 	    write_in_full(cmd->in, "\n", 1) < 0)
 		die(_("failed to feed promisor objects to pack-objects"));
 	return 0;
diff --git a/commit-graph.c b/commit-graph.c
index 8c72c3ac10..96d55f8885 100644
--- a/commit-graph.c
+++ b/commit-graph.c
@@ -1487,7 +1487,8 @@ static int write_graph_chunk_bloom_data(struct hashfile *f,
 	return 0;
 }
 
-static int add_packed_commits(const struct object_id *oid,
+static int add_packed_commits(struct repository *repo UNUSED,
+			      const struct object_id *oid,
 			      struct packed_git *pack,
 			      uint32_t pos,
 			      void *data)
diff --git a/object-store-ll.h b/object-store-ll.h
index 710130cd06..a9904687d6 100644
--- a/object-store-ll.h
+++ b/object-store-ll.h
@@ -538,7 +538,8 @@ int for_each_loose_object(each_loose_object_fn, void *,
  * Each pack is visited in an unspecified order. By default, objects within a
  * pack are visited in pack-idx order (i.e., sorted by oid).
  */
-typedef int each_packed_object_fn(const struct object_id *oid,
+typedef int each_packed_object_fn(struct repository *repo,
+				  const struct object_id *oid,
 				  struct packed_git *pack,
 				  uint32_t pos,
 				  void *data);
diff --git a/packfile.c b/packfile.c
index 1867c2d844..831d2c2c74 100644
--- a/packfile.c
+++ b/packfile.c
@@ -2199,7 +2199,7 @@ int for_each_object_in_pack(struct repository *repo,
 			return error("unable to get sha1 of object %u in %s",
 				     index_pos, p->pack_name);
 
-		r = cb(&oid, p, index_pos, data);
+		r = cb(repo, &oid, p, index_pos, data);
 		if (r)
 			break;
 	}
@@ -2237,7 +2237,8 @@ int for_each_packed_object(struct repository *repo, each_packed_object_fn cb,
 	return r ? r : pack_errors;
 }
 
-static int add_promisor_object(const struct object_id *oid,
+static int add_promisor_object(struct repository *repo,
+			       const struct object_id *oid,
 			       struct packed_git *pack UNUSED,
 			       uint32_t pos UNUSED,
 			       void *set_)
@@ -2246,12 +2247,12 @@ static int add_promisor_object(const struct object_id *oid,
 	struct object *obj;
 	int we_parsed_object;
 
-	obj = lookup_object(the_repository, oid);
+	obj = lookup_object(repo, oid);
 	if (obj && obj->parsed) {
 		we_parsed_object = 0;
 	} else {
 		we_parsed_object = 1;
-		obj = parse_object(the_repository, oid);
+		obj = parse_object(repo, oid);
 	}
 
 	if (!obj)
diff --git a/reachable.c b/reachable.c
index ecf7ccf504..f8dc2731d6 100644
--- a/reachable.c
+++ b/reachable.c
@@ -274,7 +274,8 @@ static int add_recent_loose(const struct object_id *oid,
 	return 0;
 }
 
-static int add_recent_packed(const struct object_id *oid,
+static int add_recent_packed(struct repository *repo,
+			     const struct object_id *oid,
 			     struct packed_git *p,
 			     uint32_t pos,
 			     void *data)
@@ -285,7 +286,7 @@ static int add_recent_packed(const struct object_id *oid,
 	if (!want_recent_object(data, oid))
 		return 0;
 
-	obj = lookup_object(the_repository, oid);
+	obj = lookup_object(repo, oid);
 
 	if (obj && obj->flags & SEEN)
 		return 0;
diff --git a/revision.c b/revision.c
index df1037dcaa..97f5e59258 100644
--- a/revision.c
+++ b/revision.c
@@ -3603,7 +3603,8 @@ void reset_revision_walk(void)
 	clear_object_flags(SEEN | ADDED | SHOWN | TOPO_WALK_EXPLORED | TOPO_WALK_INDEGREE);
 }
 
-static int mark_uninteresting(const struct object_id *oid,
+static int mark_uninteresting(struct repository *repo UNUSED,
+			      const struct object_id *oid,
 			      struct packed_git *pack UNUSED,
 			      uint32_t pos UNUSED,
 			      void *cb)